#
# skload.pl
# ---------
#
# Plugin for getCharts.pl to download file for specified date/time from http://www.shmu.sk/sk/?page=65
# ----------------------------------------------------------------------------------------------------
#
# Copyright (C) 2008 Francis Breame
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# For details of the GNU General Public License see
# http://perldoc.perl.org/perlgpl.html, or write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#
# Author:	Francis Breame G8ISI
# 		vf0123@btinternet.com
#
#
#
# 1.0.0	0812121	Initial release.

use strict "vars";

use LWP;
use HTTP::request;
use HTTP::response;
use HTTP::headers;

sub err
{
	print shift;
	exit 8;
}

sub doHTTP
{
	my $url    = shift;
	my $toPath = shift;

	my ($ua, $hdr, $request, $response, $data);

	#print STDERR "Getting from '$url' to '$toPath'\n";

	$ua = LWP::UserAgent->new;
	$hdr = HTTP::Headers->new;
	$request = HTTP::Request->new(GET => $url, $hdr);
	$response = $ua->request($request); 

	if ($response->is_success)
	{
		$data = $response->content_ref; 
		@$toPath = split /\n/, $$data;
	}

	#print STDERR "Status = ".$response->code."\n";

	return $response->code;
}


my $url		 = shift;	# e.g. "http://www.shmu.sk/sk/?page=65&mt=2"
my $datetime	 = shift;	# e.g. "11.12.2008 04:15"

my ($date,$time) = split / +/, $datetime;

my ($ret,@html,@refs,$j,$s);

if ($date!~/^\d\d\.\d\d\.\d\d\d\d$/)
{
	err "Invalid date '$date' - must be in format dd.mm.yyyy"; 
}

if ($time!~/^\d\d:\d\d$/)
{
	err "Invalid time '$time' - must be in format hh:mm"; 
}

err "Couldn't read html from '$url'" if (doHTTP($url,\@html,1) != 200);

# Scan for the filenames
foreach $s (@html)
{
	if ($s =~ /^img_item\[(\d+)\]="(.+)"/)
	{
		$refs[$1]=$2;
	}
}	

# Now find the index of the one we want
undef $j;
foreach $s (@html)
{
	if ($s =~ /^<option\s+value="(\d+)".*$date\s+$time/)
	{
		$j = $1;
		last;
	}
}

if (defined $j && $j<=$#refs)
{
	$url =~ m+(.*?//.*?)(/|$)+;		# Extract base part of url
	print "$1$refs[$j]";
}
else
{
	err "Can't find any image for $date $time";
}

